Index: uspace/lib/usb/hcd.c
===================================================================
--- uspace/lib/usb/hcd.c	(revision 2185776425a406b08bd1bc13dcb72da629db02f3)
+++ uspace/lib/usb/hcd.c	(revision af894a21f770d0fbb50043118dbc9445ae68f6c3)
@@ -40,10 +40,17 @@
 #include <errno.h>
 
+/** Information about pending transaction on HC. */
 typedef struct {
+	/** Phone to host controller driver. */
 	int phone;
+	/** Data buffer. */
 	void *buffer;
+	/** Buffer size. */
 	size_t size;
+	/** Storage for actual number of bytes transferred. */
 	size_t *size_transferred;
+	/** Initial call replay data. */
 	ipc_call_t reply;
+	/** Initial call identifier. */
 	aid_t request;
 } transfer_info_t;
@@ -355,5 +362,17 @@
  * =================
  */
- 
+
+/** Send data to HCD.
+ *
+ * @param phone Opened phone to HCD.
+ * @param method Method used for calling.
+ * @param target Target device.
+ * @param buffer Data buffer (NULL to skip data transfer phase).
+ * @param size Buffer size (must be zero when @p buffer is NULL).
+ * @param handle Storage for transaction handle (cannot be NULL).
+ * @return Error status.
+ * @retval EINVAL Invalid parameter.
+ * @retval ENOMEM Not enough memory to complete the operation.
+ */
 static int async_send_buffer(int phone, int method,
     usb_target_t target,
@@ -405,4 +424,19 @@
 }
 
+/** Prepare data retrieval.
+ *
+ * @param phone Opened phone to HCD.
+ * @param method Method used for calling.
+ * @param target Target device.
+ * @param buffer Buffer where to store retrieved data
+ * 	(NULL to skip data transfer phase).
+ * @param size Buffer size (must be zero when @p buffer is NULL).
+ * @param actual_size Storage where actual number of bytes transferred will
+ * 	be stored.
+ * @param handle Storage for transaction handle (cannot be NULL).
+ * @return Error status.
+ * @retval EINVAL Invalid parameter.
+ * @retval ENOMEM Not enough memory to complete the operation.
+ */
 static int async_recv_buffer(int phone, int method,
     usb_target_t target,
@@ -444,4 +478,14 @@
 }
 
+/** Read buffer from HCD.
+ *
+ * @param phone Opened phone to HCD.
+ * @param hash Buffer hash (obtained after completing IN transaction).
+ * @param buffer Buffer where to store data data.
+ * @param size Buffer size.
+ * @param actual_size Storage where actual number of bytes transferred will
+ * 	be stored.
+ * @return Error status.
+ */
 static int read_buffer_in(int phone, ipcarg_t hash,
     void *buffer, size_t size, size_t *actual_size)
@@ -475,5 +519,14 @@
 }
 
-
+/** Blocks caller until given USB transaction is finished.
+ * After the transaction is finished, the user can access all output data
+ * given to initial call function.
+ *
+ * @param handle Transaction handle.
+ * @return Error status.
+ * @retval EOK No error.
+ * @retval EBADMEM Invalid handle.
+ * @retval ENOENT Data buffer associated with transaction does not exist.
+ */
 int usb_hcd_async_wait_for(usb_handle_t handle)
 {
@@ -528,4 +581,5 @@
 }
 
+/** Send interrupt data to device. */
 int usb_hcd_async_transfer_interrupt_out(int hcd_phone,
     usb_target_t target,
@@ -540,4 +594,5 @@
 }
 
+/** Request interrupt data from device. */
 int usb_hcd_async_transfer_interrupt_in(int hcd_phone,
     usb_target_t target,
@@ -552,4 +607,5 @@
 }
 
+/** Start WRITE control transfer. */
 int usb_hcd_async_transfer_control_write_setup(int hcd_phone,
     usb_target_t target,
@@ -564,4 +620,5 @@
 }
 
+/** Send data during WRITE control transfer. */
 int usb_hcd_async_transfer_control_write_data(int hcd_phone,
     usb_target_t target,
@@ -576,4 +633,5 @@
 }
 
+/** Terminate WRITE control transfer. */
 int usb_hcd_async_transfer_control_write_status(int hcd_phone,
     usb_target_t target,
@@ -587,4 +645,5 @@
 }
 
+/** Start READ control transfer. */
 int usb_hcd_async_transfer_control_read_setup(int hcd_phone,
     usb_target_t target,
@@ -599,4 +658,5 @@
 }
 
+/** Request data during READ control transfer. */
 int usb_hcd_async_transfer_control_read_data(int hcd_phone,
     usb_target_t target,
@@ -611,4 +671,5 @@
 }
 
+/** Terminate READ control transfer. */
 int usb_hcd_async_transfer_control_read_status(int hcd_phone,
     usb_target_t target,
